;name scan-dm
;author David Moore <dm@groupinfo.com>

; strategy
; --------
; 1. create a small decoy away from code
; 2. scan briefly through core; compare pairs that are a short interval
;    apart; if a pair is unequal, then carpet that interval with SPL bombs
; 3. write SPL to the entire core sequentially (step = 1)
; 4. do another SPL pass with spiral-imp-killing step (step = 381)
;    381 * 21 == 8001 == 1
; 5. finally, continuously DAT wipe for victory
;
; everything (except decoy) is compacted into the space of 13 lines;
; "djn.f <0, {-1" is used to mutate the existing code into instructions
; needed for next phase

step   equ 848   ; scan pattern (848 == 2*2*2*2*53)
apart  equ 8     ; difference between the two scan pointers
time   equ 482   ; number of scanned pairs
length equ 13    ; spl carpet length
temp   equ 17    ; best offset for minimum gap length in spiral clear

       add.f kill, scan
scan   sne (2+apart)+((time+temp)*step), (2)+((time+temp)*step)
count  djn -2, #time             ; scan until time runs out

       mov.b  scan,  dest
mute   sub.b  stun,  @2
       mov     *-1, <dest        ; carpet bomber, core clear
       djn      -1,  #0

       jmn  count, count         ; still scanning?

       djn.f <0, {-1             ; switch between modes of operation

       spl #(kill-mute), -382    ; 2nd pass bomb (spiral swipe)
stun   spl #(kill-mute), -length ; 1st pass bomb, carpet bomb
kill   dat #-step, -step         ; 3rd pass bomb

dest   dat 0,0   ; carpet/clear pointer

for 80
  dat 0,0
rof

blur   equ 6000 ; decoy location

decoy  mov bait, <scan+blur+0
       mov <scan+blur+1, <scan+blur+3
       mov {scan+blur+4, {scan+blur+6
       mov {scan+blur+7, {scan+blur+9
       jmp scan, <scan+blur+10
bait   dat {1, <1

end decoy
